; TXTPLOT3.LSP  /  Foe 96-02-20
;
; Dieses Programm aktualisiert vor dem Plotten das Textelement, welches zur
; Identifikation dient. (Plot-Datum/Uhrzeit & Dateiname)
;
;
; pzeit      Datum generiert aus SYS-Variable mittels DIESEL
; fname      Dateiname aus SYS-Variablen
; ptext      Kompletter Textinhalt
; neu_ptext  Referenz Text-Liste zum Neugenerieren
;            (falls kein Textelement im Plan)
; asatz      SSX-Auswahlsatz fuer Textelement (falls vorhanden)
; basis      Einfuegepunkt fuer Text (falls nicht vorhanden)
; ename      Zeiger auf Textelement
; eliste     Elementliste von Textelement
;
(defun aktual (ename)
  (if (not ename)
    (alert "\n  *ERROR*  \n")
    (progn
      (while ename
        ;Elementliste
        (setq eliste (entget ename))
        (if (or (equal (cdr (assoc 2 eliste)) "DATEI") (equal (cdr (assoc 2 eliste)) "AUF.NR."))
          (progn
            ;Text erneuern
            (entmod (subst (cons 1 ptext) (assoc 1 eliste) eliste))
            ;Element updaten
            (entupd ename)
          )
        )
        (setq ename (entnext ename))
      )
    )
  )
)

(princ "\n\tPlot-Datum/Uhrzeit aktualisiert - v1.1.6 [99-10-15]")
(setq pzeit (menucmd "M=$(edtime,$(getvar,date),YY-MO-DD/HH:MM)"))
(setq fname (findfile (getvar "DWGNAME")))
(setq ptext (strcat pzeit " - " fname))

(if (wcmatch (getvar "acadver") "*14*")
  (setq asatz (ssget "_W" (getvar "VSMIN") (getvar "VSMAX")
    '((-4 . "<OR") (2 . "SK_DAT") (2 . "A[0-4]*") (2 . "CA*") (-4 . "OR>") (66 . 1)))
  )
  (setq asatz (ssget "X" 
    '((-4 . "<OR") (2 . "SK_DAT") (2 . "A[0-4]*") (2 . "CA*") (-4 . "OR>") (66 . 1)))
  )
)

(if (and (not asatz) (= (getvar "tilemode") 0))
  (progn
    (command "_mspace")
    (if (wcmatch (getvar "acadver") "*14*")
      (setq asatz (ssget "_C" (getvar "VSMIN") (getvar "VSMAX")
        '((-4 . "<OR") (2 . "SK_DAT") (2 . "A[0-4]*") (2 . "CA*") (-4 . "OR>") (66 . 1)))
      )
      (setq asatz (ssget "X" 
        '((-4 . "<OR") (2 . "SK_DAT") (2 . "A[0-4]*") (2 . "CA*") (-4 . "OR>") (66 . 1)))
      )
    )
  )
)

(if asatz
  (progn
    (if (> (sslength asatz) 1)
      (progn
        (alert "\n                ACHTUNG!\nEs wurden mehrere Blcke gefunden!\n")
        (grclear)
        (setq c -1)
        (repeat (sslength asatz)
          (redraw (ssname asatz (setq c (1+ c))) 1)
        )
        (setq ename (car (entsel "\n>>Bitte einen Blck whlen: ")))
        (aktual ename)
        (redraw)
      )
      (progn
        ;Elementzeiger
        (setq ename (ssname asatz 0))
        (aktual ename)
      )
    )
  )
  (progn
    (princ "\n\tKEIN TEXT GEFUNDEN\n\n")
  )
)

(command "_pspace")
(setq aktual nil)
;
; Alle Variablen ruecksetzen
;
(setq pzeit nil
      fname nil
      ptext nil
      neu_ptext nil
      asatz nil
      basis nil
      ename nil
      eliste nil
)
;
;;(command "ksich")
(princ)  ;ENDE
 
